##
## Planche 2. Manipulation de donnees
##


##
## Exercice 1. Emploi des jeunes en Europe
##
rm(list = ls())

#1. 
emploi_eur <- read.table("../data/emploi.txt", header=FALSE,col.names=c("Pays","Taux"), sep="\t",nrow=25, skip=4, blank.lines.skip=TRUE,as.is=c(TRUE,TRUE))

#2.
mean(emploi_eur$Taux)
median(emploi_eur$Taux)
sd(emploi_eur$Taux)

#3.
emploi_eur$Pays[which.max(emploi_eur$Taux)]
emploi_eur$Pays[which.min(emploi_eur$Taux)]



##
## Exercice 2. Consomation d'Alcool
##
rm(list = ls())


#1.

alcool1 <- read.table("../data/Alcool.txt",dec=",", skip=4,header=FALSE, blank.lines.skip=TRUE,as.is=c(TRUE,TRUE),nrow=35,col.names=c("Annee","Conso"))
 
alcool2 <- read.fwf("../data/Alcool.txt",widths=c(4,4),dec=",", skip=4,header=FALSE,blank.lines.skip=TRUE,n=71,col.names=c("Annee","Conso"))
# blanck.lines.skip ne fonctionne pas ?

#2.
ts(alcool1$Conso,start = c(min(alcool1$Annee)),end=c(max(alcool1$Annee)),deltat=1)




##
## Exercice 3. Population mondiale
##
rm(list = ls())

#1.
pop_eur <- read.table("../data/population.txt",sep="!",skip=4,blank.lines.skip=TRUE,as.is=c(TRUE,TRUE,TRUE,TRUE),nrow=36,comment.char="%",col.names=c("Pays","Pop","Dens","Urb"),na.string="-") 
moy <- c("moyenne",mean(pop_eur$Pop),mean(pop_eur$Dens),mean(pop_eur$Urb,na.rm=TRUE))
europe <- pop_eur
europe[nrow(europe)+1,] <- moy
write.table(europe,file="../data/europe.txt",quote=FALSE,row.names=FALSE)

#2.
pop_afr <- read.table("../data/population.txt",sep="!",skip=82,blank.lines.skip=TRUE,as.is=c(TRUE,TRUE,TRUE,TRUE),nrow=20,comment.char="%",col.names=c("Pays","Pop","Dens","Urb"),na.string="-") 
moy <- c("moyenne",mean(pop_afr$Pop),mean(pop_afr$Dens),mean(pop_afr$Urb,na.rm=TRUE))
afrique <- pop_afr
afrique[nrow(afrique)+1,] <- moy
write.table(afrique,file="../data/afrique.txt",quote=FALSE,row.names=FALSE)

pop_amr <- read.table("../data/population.txt",sep="!",skip=126,blank.lines.skip=TRUE,as.is=c(TRUE,TRUE,TRUE,TRUE),nrow=14,comment.char="%",col.names=c("Pays","Pop","Dens","Urb"),na.string="-") 
moy <- c("moyenne",mean(pop_amr$Pop),mean(pop_amr$Dens),mean(pop_amr$Urb,na.rm=TRUE))
amerique <- pop_amr
amerique[nrow(amerique)+1,] <- moy
write.table(amerique,file="../data/amerique.txt",quote=FALSE,row.names=FALSE)


pop_asi <- read.table("../data/population.txt",sep="!",skip=155,blank.lines.skip=TRUE,as.is=c(TRUE,TRUE,TRUE,TRUE),nrow=26,comment.char="%",col.names=c("Pays","Pop","Dens","Urb"),na.string="-") 
moy <- c("moyenne",mean(pop_asi$Pop),mean(pop_asi$Dens),mean(pop_asi$Urb,na.rm=TRUE))
asie <- pop_asi
asie[nrow(asie)+1,] <- moy
write.table(asie,file="../data/asie.txt",quote=FALSE,row.names=FALSE)

pop_oca <- read.table("../data/population.txt",sep="!",skip=209,blank.lines.skip=TRUE,as.is=c(TRUE,TRUE,TRUE,TRUE),nrow=4,comment.char="%",col.names=c("Pays","Pop","Dens","Urb"),na.string="-") 
moy <- c("moyenne",mean(pop_oca$Pop),mean(pop_oca$Dens),mean(pop_oca$Urb,na.rm=TRUE))
oceanie <- pop_oca
oceanie[nrow(oceanie)+1,] <- moy
write.table(oceanie,file="../data/oceanie.txt",quote=FALSE,row.names=FALSE)




##
## Exercice 4. Données aléatoires
##
rm(list = ls())

#1.
# Normale N(m,s) m=0 s=1
m <- 0;s <- 1
aleaG <- rnorm(1000,mean=m,sd=s)
moyG <- mean(aleaG)
varG <- var(aleaG)
medG <- median(aleaG)
moyG_theo <-  m; # m
varG_theo <- s;  # s
medG_theo <- m;  # m

#2.
#Uniforme U(a,b) a=0 b=1
a <- 0;b <- 1
aleaU <- runif(1000,min=a,max=b)
moyU <- mean(aleaU)
varU <- var(aleaU)
medU <- median(aleaU)
moyU_theo <-  (a+b)/2; # (a+b)/2 
varU_theo <-(b-a)^2/3; # (b-a)^2/3
medU_theo <- (a+b)/2;  # (a+b)/2

# Bernoulli B(p) = B(1,p). p=0.5
p <- 0.5
aleaB1 <- rbinom(1000,size=1,prob=p)
moyB1 <- mean(aleaB1)
varB1 <- var(aleaB1)
medB1 <- median(aleaB1)
moyB1_theo <-  p; # p
varB1_theo <- p*(1-p); # p(1-p)
medB1_theo <- NA;

# Binome B(n,p) n=20 p=0.8
n <- 20;p <- 0.8
aleaB2 <- rbinom(1000,size=20,prob=0.8)
moyB2 <- mean(aleaB2)
varB2 <- var(aleaB2)
medB2 <- median(aleaB2)
moyB2_theo <-  n*p; # np
varB2_theo <- n*p*(1-p); # np(1-p)
medB2_theo <- floor(n*p);  # [np]

# Poisson P(lambda) lambda = 5 e^(-\lambda) lambda^k/k!
lambda <- 5
aleaP <- rpois(1000,lambda=lambda)
moyP <- mean(aleaP)
varP <- var(aleaP)
medP <- median(aleaP)
moyP_theo <-  lambda; # lambda
varP_theo <- lambda; # lambda
medP_theo <- lambda + 1/3 - 0.002/lambda;  # lambda + 1/3 - 0.002/lambda

moy_xp <- c(moyG,moyU,moyB1,moyB2,moyP)
moy_theo <- c(moyG_theo,moyU_theo,moyB1_theo,moyB2_theo,moyP_theo)
var_xp <- c(varG,varU,varB1,varB2,varP)
var_theo <- c(varG_theo,varU_theo,varB1_theo,varB2_theo,varP_theo)
med_xp <- c(medG,medU,medB1,medB2,medP)
med_theo <- c(medG_theo,medU_theo,medB1_theo,medB2_theo,medP_theo)


#3.
Alea <- data.frame(moy_xp,moy_theo,var_xp,var_theo,med_xp,med_theo,row.names=c("Normal","Unif","Bernoulli","Binome","Poisson"));

write.table(Alea,"../data/aleatoire.txt")
