##
## Planche 3 - Graphiques et programmation
##


##
## Exercice 1. Type de consultation en fonction de l'age
##
rm(list = ls())

#1.

consultations <- read.table("../data/consultation.dat",header=TRUE,sep="\t",nrow=3,skip=5,blank.lines.skip=TRUE,as.is=c(TRUE,TRUE))

#2.
x <- consultations[1,2:6]
pie()
consultations$1


##
## Exercice 2. Fonctions usuelles
##
rm(list = ls())

x <- seq(-10,10,0.1)
y <- exp(x)
plot(x,y,type="l",xlim=c(-10,10),ylim=c(-10,10))

y <- log(x)
lines(x,y,col="blue")
plot(x,y,type="l",xlim=c(-10,10),ylim=c(-10,10))


y <- x^2;
lines(x,y,col="red")

title(main="Fonctions usuelles",xlab="x",ylab="y")

y <- 3*x-6;
lines(x,y);

abline(-6,3,col="green",bg="yellow")
par(bg="yellow")

##
## Exercice 3. Tour de France
##
rm(list = ls())

#1.
tdf <- read.table("../data/tdf.dat",sep="\t",col.names=c("Year","Start Town","Start Date","End Date","Stages","Dist","Speed","Time","Winner","Country","Birth","AgeY","AgeT"))

#2.
evo_dist <- ts(tdf$Dist,start=min(tdf$Year),end=max(tdf$Year),frequency=1)
plot.ts(evo_dist)

#3.
hist(tdf$AgeY)

#4.
plot(tdf$Dist,tdf$Speed)

##
## Exercice 4.
##
rm(list = ls())

#1.
n <- 50; N <- 100
X <- rbinom(n*N,size=1,prob=0.5)
X <- matrix(alea,N,n)

#2.
S <- rowMeans(X)
Z <- (S-1/2)*2*sqrt(n)

#3.
h <- hist(Z)
title(main="histogramme, TLC")
h$breaks
h$intensities
pnorm(h$breaks[2])-pnorm(h$breaks[1])
h$intensities[1]
pnorm(h$breaks[4])-pnorm(h$breaks[3])
h$intensities[3]

#4.
my_hist <- function(n,s,p){
   N <- 100
   X <- rbinom(n*N,size=s,prob=p)
   X <- matrix(alea,N,n)
   S <- rowMeans(X)
   Z <- (S-1/2)*2*sqrt(n)
   h <- hist(Z)
   return(h)
}

#4.
my_hist <- function(n,lambda){
   N <- 100
   X <- rpois(n*N,lambda=lambda)
   X <- matrix(alea,N,n)
   S <- rowMeans(X)
   Z <- (S-lambda)*2*sqrt(n)
   h <- hist(Z)
   return(h)
}





##
## Exercice 5. Programmation élémentaire
##
rm(list = ls())


#1.

factn <- function(n){

  r <- 1
  for (k in 1:n){
    r <- r*k
  }
  return(r)
}

fact_rec <- function(n){

  if (n==1)    
    r <- 1
  else
    r <- n*fact_rec(n-1)

    return(r)
}



#2.

maximum <- function(x){

  m <- x[1]
  for( k in x){
    if(k>m)
      m <- k
  }
  return(m)
}

moyenne <- function(x){

  m <- 0
  compteur <- 0;
  for( k in x){
    compteur <- compteur+1
    m <- (m+k)
  }
  return(m/compteur)
}



##
## Exercice 5. Suite de Fibonnacci
##


fibo <- function(n){

  if(n==0)
    return(0)
  
  if(n==1)
    return(1)

  u <- fibo(n-1) + fibo(n-2)

  return(u)

}


fibo2 <- function(n){

  u0 <- 0;
  u1 <- 1;
  u <- 0;

  if(n>0)
    for(k in 1:n){
      u <- u1+u0;
      u0 <- u1;
      u1 <- u;
    }
  
  return(u)
}
